/* Various configuration options

   Cygnus IRC Services - Copyright (c) 2001-2002 Darcy Grexton
   Contact: skold@habber.net, skold @ HabberNet

   See doc/LICENSE for licensing details.
 */

/* Change these to suit your liking. */
#define CONFIGFILE	"cygnus.conf"		/* Our conf file	*/
#define PIDFILE		"cygnus.pid"		/* Our PID file		*/
#define LOGFILE		"cygnus.log"		/* Our log file		*/
#define MOTDFILE	"cygnus.motd"		/* Our MOTD file	*/
#define NEWSFILE	"cygnus.news"		/* Our News file	*/
#define ZONEFILE	"cygnus.zone"		/* TimeZone list	*/
#define NICKSERV_DB	"nickserv.db"		/* NickServ DB		*/
#define CHANSERV_DB	"chanserv.db"		/* ChanServ DB		*/
#define ROOTSERV_DB	"rootserv.db"		/* RootServ DB		*/
#define WEB_DB		"web.db"		/* Web Integration DB	*/
#define WEB_LOG		"web.log"		/* Web Integration Log	*/
#define NSREGISTER	"nsregister.email"	/* NS REGISTER E-Mail	*/
#define NSSENDPASS	"nssendpass.email"	/* NS SENDPASS E-Mail	*/
#define NSCHANGE	"nschange.email"	/* NS Change E-Mail	*/
#define CSREGISTER	"csregister.email"	/* CS REGISTER E-Mail	*/
#define CSSENDPASS	"cssendpass.email"	/* CS SENDPASS E-Mail	*/
#define MSMEMOMAIL	"msmemomail.email"	/* MS MEMOMAIL E-Mail	*/

/* These values should be sufficient on any supported IRCDs. */
#define NICKLEN		32	/* Maximum length of a nickname		*/
#define CHANNELLEN	64	/* Maximum length of a channel name	*/
#define PASSWDLEN	65	/* Maximum length of a password		*/
#define USERLEN		12	/* Maximum length of a username		*/
#define HOSTLEN		65	/* Maximum length of a hostname		*/
#define REALLEN		52	/* Maximum length of a realname		*/
#define TOPICLEN	352	/* Maximum length of a channel topic	*/
#define KEYLEN		25	/* Maximum length of a channel key	*/

/* Leave these alone too. */
#define BUFSIZE		512	/* Maximum size of a buffer		*/
#define MODESTACK_WAIT	500	/* Time (in ms) to wait for modes	*/

/* Size of the hash tables Cygnus uses. */
#define HASHSIZE 1021

/* Defines for supported IRCd types. Do NOT change these. Add new ones
   to the bottom of the list.
 */
#define DREAMFORGE	1
#define PROMETHEUS	2
#define BAHAMUT		3
#define UNREAL3		4
#define UNREAL3_2	5

/* Do you want Cygnus to generate a core file if it crashes?
   I'd suggest you leave this option on. If you experience crashes,
   the core files generated can help me track down the problem and
   fix it.
 */
#define DUMP_CORE

/* Do you want to enable the RAW and INJECT functions? These functions
   are entirely unsupported. If you crash Cygnus or your IRCd while
   using them (and it's entirely possible and quite easy to do both),
   tough luck. If you don't know how to do anything with them, tough luck.
   Do not ask me for a list of RAW and INJECT commands. If you enable
   these, you're on your own. They're not toys. :P
 */
#undef RAWINJECT

/* This is easier to type, and if your Windows compiler uses a different
   define, you can change this here. All Windows code is contained in these
   defines.
 */
#define _WIN32_VS SVSWIN32

/* Define this for Windows compiles. */
#undef SVSWIN32
