/* Response texts

   Cygnus IRC Services - Copyright (c) 2001-2002 Darcy Grexton
   Contact: skold@habber.net, skold @ HabberNet

   See doc/LICENSE for licensing details.
 */

/* Generic, misc and error replies */
#define RPL_CANT_CONNECT	"Unable to connect to server."
#define RPL_CANT_OPEN		"Can't open %s!"
#define RPL_LOST_CONNECTION	"Lost connection to %s."
#define RPL_ERROR		"Error from server: %s"
#define RPL_WRITE_ERROR		"Error writing to server."
#define RPL_NO_CONFIG		"No config file found."
#define RPL_CANT_WRITE_PID	"Cannot write PID file!"
#define RPL_UNKNOWN_COMMAND	"Unknown command \2%s\2. Type \2/%s%s%s%s HELP\2 for help."
#define RPL_UNKNOWN_OPTION	"Unknown option \2%s\2. Type \2/%s%s%s%s HELP\2 for help."
#define RPL_ACCESS_DENIED	"Access denied."
#define RPL_NO_HELP		"Sorry, there is no help available for \2%s\2."
#define RPL_NOT_SRA		"Sorry, you're not an SRA."
#define RPL_MORE_INFO		"Type \2/%s%s%s%s HELP %s\2 for more information."
#define RPL_NOT_SERVICES	"You cannot JUPE Services."
#define RPL_FORMATTING		"You must specify \2%s\2 only."
#define RPL_LIST_NOT_THERE	"\2%s\2 is not in %s list."
#define RPL_LIST_THERE		"\2%s\2 is already present or inclusive in %s %s list."
#define RPL_TOOMANYWILD		"The mask you gave contains too many wildcards. You must have at least %d non-wildcard characters."
#define RPL_MSG_LEN		"LogonMSGs are limited to \002256\002 characters. You gave \002%d\002."
#define RPL_ALREADY_SRA		"You're already authenticated as an SRA."
#define RPL_QUIT		"Quit: %s"
#define RPL_COLLISIONS		"Too many nick collisions on \2%s\2! Please reconfigure your services."
#define RPL_INVALID		"That is an invalid %s.%s"
#define RPL_LENGTH		"That %s is too long. It can be a maximum of %d characters."
#define RPL_BETTER_PASS		"Please choose another password."
#define RPL_PASS_REJECTED_SHORT	"The password you gave was too short."
#define RPL_PASS_REJECTED_LONG	"The password you gave was too long."
#define RPL_PASS_REJECTED_NICK	"The password you gave was your nickname."
#define RPL_PASS_REJECTED_WEAK	"The password you gave was too weak."
#define RPL_PASS_REJECTED_DIFF	"The passwords you gave did not match."
#define RPL_PASS_REJECTED_CHAN	"The password you gave was your channel name."
#define RPL_PASS_REJECTED_FNDR	"The password you gave was the founder's nickname."
#define RPL_NEED_IDENT		"You must be registered and identified to use the \2%s\2 command."
#define RPL_SECURE_MESSAGES	"Please use /%s%s%s%s for that command."
#define RPL_PASS_DONT_MATCH	"Those passwords don't match. Please try again."
#define RPL_NO_REGISTER		"You cannot register or link that nickname."
#define RPL_EMAIL_USED		"Sorry, that E-Mail address has been used too much recently."
#define RPL_HACK_EMAIL		"Warning: Possible hacking attempt from \2%s\2: Tried to give E-Mail of \2%s\2"
#define RPL_BAD_SERVER		"Invalid servername. You cannot use wildcards."
#define RPL_SYNTAX		"Syntax: \2%s\2"
#define RPL_RESTARTING		"Restarting in %s."
#define RPL_SAVING		"Saving %s ..."
#define RPL_REMOVED		"%s was successfully removed."
#define RPL_ADDED		"%s was stored as %s."
#define RPL_KILLED_PASSFAIL	"Too many failed passwords"
#define RPL_PASSWORD_SET	"Your password is \2%s\2 - Please remember this for future use."
#define RPL_SERVICESLEAVING	"Services are shutting down. They should be back momentarily."
#define RPL_SERVICESBACK	"Services are now back online. We apologize for any inconvenience."
#define RPL_EMAIL_INSTRUCTIONS	"Instructions for completing registration have been E-Mailed to you."
#define RPL_WAITING		"Waiting for confirmation for \2DROP\2. Please \2/%s%s%s%s %s\2"
#define RPL_CONFIRM		"To confirm this action, please \2/%s%s%s%s %s %s %s %lu\2."
#define RPL_ABORTED		"Incorrect key. \2%s\2 aborted."
#define RPL_PASS_ACCEPTED	"Password accepted for \2%s\2."
#define RPL_WRONG_PASS		"Password supplied for \2%s\2 is incorrect."
#define RPL_LAST_TRY		"Last chance."
#define RPL_HELP_START		"*** \2%s Help\2 ***"
#define RPL_HELP_END		"*** \2End of Help\2 ***"
#define RPL_GETPASS		"The %s for \2%s\2%s%s%s is \2%s\2."
#define RPL_SETPASS		"The password for \2%s\2%s%s%s has been set to \2%s\2."
#define RPL_SENDPASS		"The password for \2%s\2%s%s%s has been E-Mailed to \2%s\2"
#define RPL_PASS_GLOBAL		"\2%s\2 used %s on \2%s\2%s%s%s"
#define RPL_LIST_FULL		"Sorry, the \2%s\2 list is full."
#define RPL_LIST_EMPTY		"%s%s \2%s\2 list is empty."
#define RPL_NOT_ONLINE		"The nickname \2%s\2 is not in use."
#define RPL_IN_USE		"The nickname \2%s\2 is in use by someone else."
#define RPL_KEY_RESENT		"The key for \2%s\2 has been re-issued."
#define RPL_TOGGLE		"%s for \2%s\2 is now %s."
#define RPL_IS_ALREADY		"%s is already %s."
#define RPL_IS_NOT		"%s is not %s."
#define RPL_YOU_DONT_EXIST	"Sorry, no user record was found for you."
#define RPL_PLEASE_RECONNECT	"Please disconnect and reconnect to the server."

/* RootServ replies */
#define RS_ACCESS_DENIED	"Access denied. Only IRCOps can use this service."
#define RS_GLOBAL_NOTICE	"Sending a global notice by request of \2%s\2."
#define RS_JUPE_MY_SERVER	"\2%s\2 attempted to JUPE my server!"
#define RS_JUPE_MY_UPLINK	"\2%s\2 attempted to JUPE my uplink!"
#define RS_JUPE_MY_NICK		"\2%s\2 attempted to JUPE %s!"
#define RS_JUPE_SUCCESSFUL	"JUPE on \2%s\2 was successful."
#define RS_JUPED		"JUPEing \2%s\2 by request of \2%s\2."
#define RS_AKILL_FORMAT		"Invalid %sAKill. The proper format is username@hostname"
#define RS_AKILL_ADDED		"AKill on \2%s\2 successfully added."
#define RS_AKILL_ADDED_GLOBOP	"\2%s\2 %s%sAKilled \2%s\2: %s"
#define RS_AKILL_LIST		"*** \2AKill List%s%s%s\2 ***"
#define RS_AKILL_LIST_MATCH	"[%d] %s (%s (Expires: %s%s)) %s"
#define RS_PAKILL_LIST_MATCH	"[%d] %s (%s (\2Permanent\2)) %s"
#define RS_AKILL_LIST_END	"*** \2End of AKills\2 ***"
#define RS_AKILL_DELETED	"AKill on \2%s\2 has been deleted."
#define RS_AKILL_DELETED_GLOBOP	"\2%s\2 deleted %s%sAKill on %s"
#define RS_ALL_AKILL_DELETED	"All %d AKills have been deleted."
#define RS_ALL_AKILL_DEL_GLOBOP	"\2%s\2 deleted all %d AKills."
#define RS_AKILL_NOT_FOUND	"No AKills matching \2%s\2 found."
#define RS_AKILL_LEARNED	"Learned new AKill from %s: %s (%s)"
#define RS_AKILL_FORGOTTEN	"Forgetting AKill on %s: Removed by %s"
#define RS_CLONES_START		"*** \2Current Clones List: Showing \2%d\2 match%s\2 ***"
#define RS_CLONES_HEADER	"Host                                         Nicknames"
#define RS_CLONES_END		"*** \2End of Clones List: \2%d\2 match%s shown\2 ***"
#define RS_TRIGGER_FORMAT	"Triggers must be in user@host format."
#define RS_TRIGGER_ADDED	"\2%s\2 has been added to the Trigger list."
#define RS_RETRIGGER		"\2%s\2 was ReTriggered to \2%d\2."
#define RS_TRIGGER_LIST		"[%d] %s (Limit: %d)"
#define RS_TRIGGER_DELETED	"Trigger %s %s has been deleted."
#define RS_TRIGGER_NOT_FOUND	"No Triggers matching \2%s\2 found."
#define RS_ALL_TRIGGER_DELETED	"%d Triggers have been deleted."
#define RS_EXCEPTION_FORMAT	"Exceptions must be in user@host format."
#define RS_EXCEPTION_ADDED	"\2%s\2 has been added to the Exception list."
#define RS_ALREADY_EXCEPT	"\2%s\2 is already in the Exception list."
#define RS_EXCEPTION_LIST	"[%d] %s"
#define RS_EXCEPTION_DELETED	"Exception %s %s has been deleted."
#define RS_EXCEPTION_NOT_FOUND	"No Exceptions matching \2%s\2 found."
#define RS_EXCEPTIONS_DELETED	"%d Exceptions have been deleted."
#define RS_CSOP_ADDDEL		"\2%s\2 is no%s in the CSOp list."
#define RS_CSOP_LIST		"[%d] %s (%s)"
#define RS_DB_SYNC_COMPLETE	"DataBase Sync Completed."
#define RS_MAX_CLONES		"Too many connections from your host"
#define RS_NOW_SRA		"You are now recognized as an SRA."
#define RS_NOW_SRA_GLOBOP	"SRA -- %s!%s@%s is now SRA."
#define RS_NO_LONGER_SRA	"You are no longer an SRA."
#define RS_FAILED_AUTH		"Failed AUTH attempt by %s!%s@%s"
#define RS_SHUTTING_DOWN	"Cygnus terminating by request of %s: %s"
#define RS_RESTARTING		"Cygnus restarting in %s by request of %s: %s"
#define RS_FORCE_UPDATE		"Forcing DB update by request of \2%s\2."
#define RS_DEBUG_LEVEL		"Debugging now at level %d: %s"
#define RS_SETTINGS_START	"*** \2Cygnus Settings\2 ***"
#define RS_SETTINGS		"%-30s: %s"
#define RS_SETTINGS_MULTI	"%-30s: %s%s%s"
#define RS_SETTINGS_END		"*** \2End of Settings\2 ***"
#define RS_DOING_REHASH		"Rehashing %s by request of \2%s\2."
#define RS_RESETTING_NEWS	"Resetting NEWS by request of \2%s\2."
#define RS_NEWS_RESET		"All NEWS flags have been reset."
#define RS_LOGS_CYCLED		"Services' Logfiles have been cycled."
#define RS_LOG_START		"*** \2Searching Logs: Showing \2%d\2 match%s\2 ***"
#define RS_LOG_END		"*** \2End of Log Search: \2%d\2 match%s shown\2 ***"
#define RS_FLOOD_TRIGGERED	"You have triggered Services' flood protection."
#define RS_FLOOD_TRIGGER	"Please do not send more than %d messages in %s."
#define RS_FLOOD_FIRST		"This is your first offence. You are being ignored for 30 seconds."
#define RS_FLOOD_SECOND		"This is your second offence. You will be AKilled if you flood again."
#define RS_AKILL_FLOOD		"Flooding services is not allowed."
#define RS_FLOOD_GLOBOPS	"\2%s\2 is flooding Services.%s"
#define RS_STATS_START		"*** \2Cygnus Statistics\2 ***"
#define RS_STATS_NETWORK	"Current network statistics:"
#define RS_STATS		"%-10s: %d"
#define RS_STATS_SERVICES	"Current services statistics:"
#define RS_STATS_UPTIME		"%s: %d days, %d:%02d:%02d"
#define RS_STATS_END		"*** \2End of Stats\2 ***"
#define RS_LIST_START		"*** \2%s List \2***"
#define RS_LIST_END		"*** \2End of %s \2***"
#define RS_LIST_END_MATCHES	"*** \2End of %s - \2%d\2 match%s shown\2 ***"
#define RS_LISTNICKS_HEADER	"NickName                  Last Address/Host Nickname"
#define RS_LISTNICKS_LIST	"%-25s %s"
#define RS_LISTCHANS_HEADER	"Channel                   Founder"
#define RS_LISTCHANS_LIST	"%-25s %s"

/* NickServ replies */
#define NS_NOT_SERVICES_NICK	"You cannot register a Services nickname."
#define NS_ALREADY_REGISTERED	"Your nickname is already registered."
#define NS_REGISTERED		"Your nickname is now registered."
#define NS_REGISTERED_TEMP	"Your nickname has been temporarily registered."
#define NS_TEMP_EXPIRE		"If you do not complete registration within \2%s\2, your nickname will expire."
#define NS_REGISTER_INFO	"For more information on owning a nickname, please go to:"
#define NS_COLLISION_INFO	"For more information on what this means, please go to:"
#define NS_NOT_REGISTERED	"The nickname \2%s\2 is not registered."
#define NS_INFO_START		"*** \2%s is\2 %s"
#define NS_INFO_RECOGNIZED	"This nickname is in use, but has not been identified for."
#define NS_INFO_WAITING		"\2This nickname is not yet fully registered.\2"
#define NS_INFO_FROZEN		"\2This nickname is Frozen.\2"
#define NS_INFO_FROZEN_BY	"Frozen by    : %s"
#define NS_INFO_FROZEN_WHY	"   Reason    : %s"
#define NS_INFO_FROZEN_TIME	"     Time    : %s"
#define NS_INFO_HOST		"Host Nick    : %s"
#define NS_INFO_LAST_MASK	"Last Address : %s"
#define NS_INFO_LAST_USED	"Last Used    : %s (%s ago)"
#define NS_INFO_REGISTERED	"Registered   : %s (%s ago)"
#define NS_INFO_ZONE		"TimeZone     : %s (%s): %s"
#define NS_INFO_EMAIL		"E-Mail       : %s"
#define NS_INFO_URL		"URL          : %s"
#define NS_INFO_UIN             "UIN          : %d"
#define NS_INFO_NAME		"Real Name    : %s"
#define NS_INFO_AGE		"Age          : %d"
#define NS_INFO_SEX		"Sex          : %s"
#define NS_INFO_LOCATION	"Location     : %s"
#define NS_INFO_FORWARD		"Memo Forward : %s"
#define NS_INFO_LINKS		"Linked Nicks : %d"
#define NS_INFO_FLAGS		"Options      : %s"
#define NS_INFO_END		"*** \2End of Info\2 ***"
#define NS_KILLED_ENFORCEMENT	"NickName Enforcement"
#define NS_ACCESS_ADDED		"\2%s\2 has been added to your \2ACCESS\2 list."
#define NS_ACCESS_REMOVED	"\2%s\2 has been removed from your \2ACCESS\2 list."
#define NS_ACCESS_LIST		"Listing \2ACCESS\2 entries for \2%s\2:"
#define NS_ACCESS_LIST_HEADER	"Num Mask"
#define NS_ACCESS_END		"*** \2End of List - %d entries total\2 ***"
#define NS_DROPPED		"Nickname \2%s\2 has been dropped."
#define NS_NOT_SELF		"You cannot \2%s\2 yourself."
#define NS_NOT_HELD		"Nickname \2%s\2 is not being held."
#define NS_RECOVERED		"Nickname \2%s\2 has been recovered."
#define NS_NICK_OWNED		"Your nickname is owned by someone else. Please choose another."
#define NS_IDENTIFY		"If this is your nickname, type \2/%s%s%s%s IDENTIFY Password\2"
#define NS_60_SECONDS		"You have \00260\002 seconds to comply or your nick will be changed."
#define NS_40_SECONDS		"You have \00240\002 seconds to comply."
#define NS_20_SECONDS		"You have \00220\002 seconds to comply. This is your last warning."
#define NS_NICK_CHANGED		"You did not identify for this nickname, so your nickname has been changed."
#define NS_IDENTIFY_ONE		"You must be identified to at least one nickname in order to use \2LINK\2."
#define NS_MAX_LINKS		"Sorry, you cannot have more than \2%d\2 linked nicks."
#define NS_MAX_LINKS_OTHER	"Sorry, \2%s\2 has the maximum number of linked nicks. (%d)"
#define NS_NICKS_LINKED		"Nickname \2%s\2 has been linked to \2%s\2."
#define NS_NICKS_MERGED		"Nickname \2%s\2 has been merged into \2%s\2."
#define NS_NICKS_UNLINKED	"Nickname \2%s\2 is no longer linked to \2%s\2."
#define NS_LINKS_LIST		"Nicknames linked to \2%s\2: %s"
#define NS_NO_LINKS		"Nickname \2%s\2 has no linked nicks."
#define NS_CHANS_LIST		"Channels registered under \2%s\2: %s"
#define NS_NO_CHANS		"Nickname \2%s\2 has no channels registered."
#define NS_NOT_LINKED		"Nickname \2%s\2 is not linked to \2%s\2."
#define NS_LINK_SELF		"You cannot link a nickname to itself."
#define NS_FROZEN		"Nickname \2%s\2 has been Frozen."
#define NS_FROZEN_HOST		"Host nickname \2%s\2 for nickname \2%s\2 has been Frozen."
#define NS_UNFROZEN		"Nickname \2%s\2 has been unFrozen."
#define NS_UNFROZEN_HOST	"Host nickname \2%s\2 for nickname \2%s\2 has been unFrozen."
#define NS_FROZEN_REASON	"Reason: %s"
#define NS_FROZEN_CHANGED	"Your nickname will now be changed."
#define NS_FROZEN_KILLED	"You will now be removed from the network."
#define NS_ALREADY_FROZEN	"Nickname \2%s\2 is already Frozen."
#define NS_NOT_FROZEN		"Nickname \2%s\2 isn't Frozen."
#define NS_NICK_MARKED		"Nickname \2%s\2 is Marked, unable to %sPASS."
#define NS_NICK_FROZEN		"Nickname \2%s\2 is Frozen, it cannot be used."
#define NS_STATUS		"Your current status: %s"
#define NS_STATUS_OTHER		"Status for \2%s\2: %s"
#define NS_STATUS_CHANS		"You have identified for founder access on: %s"
#define NS_STATUS_CHANS_OTHER	"\2%s\2 has founder access on: %s"
#define NS_STATUS_NONE		"You have no access to any nicknames."
#define NS_STATUS_NONE_OTHER	"\2%s\2 has no access to any nicknames."
#define NS_WAIT_REG		"Please wait %s before registering another nickname."
#define NS_TRY_LINK		"While you are waiting, consider using the \2LINK\2 command."
#define NS_HELP_LINK		"\2/%s%s%s%s HELP LINK\2 for more information on \2LINK\2."
#define NS_TOO_MANY_EMAILS	"Sorry, too many nicknames have that E-Mail."
#define NS_NOT_AUTHED		"Sorry, the nickname \2%s\2 is not yet fully registered. It cannot be used."
#define NS_CANT_SENDPASS	"Sorry, \2%s\2 doesn't have an E-Mail set. Unable to SENDPASS."
#define NS_CONFIRM_EMAIL	"A confirmation E-Mail has been sent to \2%s\2."
#define NS_CONFIRM_CHANGE	"Please follow the instructions in the E-Mail to confirm this action."
#define NS_CONFIRM_TIMEOUT	"If you do not follow the instructions within %s, your E-Mail will not be changed."
#define NS_ZONE_MULTIPLE	"The following TimeZones matched \2%s\2:"
#define NS_ZONE_LIST		"[%d] %s (%s): %s"
#define NS_ZONE_SET		"Please \2/%s%s%s%s SET ZONE Num\2 to set your TimeZone."

/* ChanServ Replies */
#define CS_NOT_VALID		"\2%s\2 is not a valid channel name. Channels must contain #."
#define CS_BE_OPPED		"You must be opped in \2%s\2 before registering it."
#define CS_CANNOT_REGISTER	"Channel \2%s\2 cannot be registered."
#define CS_ALREADY_REGISTERED	"Channel \2%s\2 is already registered."
#define CS_NOT_REGISTERED	"Channel \2%s\2 is not registered."
#define CS_WAIT_REG		"Please wait %s before registering another channel."
#define CS_WAIT_AUTH		"As soon as a CSOp verifies your channel registration, you may use it."
#define CS_WAIT_AWHILE		"This may take up to a day or two. Please be patient."
#define CS_WAITING_VERIFY	"Channel verification: \2%s\2 is awaiting verification."
#define CS_VERIFY_WAITING	"There are \2%d\2 channels awaiting verification."
#define CS_VERIFY_NOT_FOUND	"\2%s\2 was not found in the verification list."
#define CS_CSOP_VERIFIED	"Verification for \2%s\2 has been accepted by %s. Waited for %s."
#define CS_CSOP_DENIED		"Verification for \2%s\2 has been denied by %s. Waited for %s."
#define CS_VERIFIED		"Your channel (\2%s\2) has been verified. You may use it now."
#define CS_DENIED		"Sorry, your channel registration for \2%s\2 has been denied.%s%s"
#define CS_VERIFY_TOLIST	"To list channels awaiting verification, \2/%s%s%s%s %s\2"
#define CS_VERIFY_LIST_START	"*** \2Listing channels awaiting verification\2 ***"
#define CS_VERIFY_LIST		"Num Channel                  Founder                  Owned   Waiting for"
#define CS_VERIFY_LIST_END	"*** \2End of list - %d channels waiting\2 ***"
#define CS_REGISTER_INFO	"For more information on owning a channel, please go to:"
#define CS_REGISTERED		"Channel \2%s\2 is now registered under the nickname \2%s\2."
#define CS_REGISTERED_TEMP	"Channel \2%s\2 has been temporarily registered."
#define CS_TEMP_EXPIRE		"If you do not complete registration within \2%s\2, your channel will expire."
#define CS_INFO_START		"*** \2Info on %s\2"
#define CS_INFO_FOUNDER		"Founder    : %s%s%s%s"
#define CS_INFO_SUCCESSOR	"Successor  : %s%s%s%s"
#define CS_INFO_REGISTERED	"Registered : %s (%s ago)"
#define CS_INFO_LAST_USED	"Last Used  : %s (%s ago)"
#define CS_INFO_WAITING		"\2This channel is not yet fully registered.\2"
#define CS_INFO_FROZEN		"\2This channel is Frozen.\2"
#define CS_INFO_FROZEN_BY	"Frozen by  : %s"
#define CS_INFO_FROZEN_WHY	"   Reason  : %s"
#define CS_INFO_FROZEN_TIME	"     Time  : %s"
#define CS_INFO_MLOCK		"ModeLock   : %s%s"
#define CS_INFO_URL		"URL        : %s"
#define CS_INFO_TOPICLOCK	"TopicLock  : %s"
#define CS_INFO_MEMOLEVEL	"MemoLevel  : %s"
#define CS_INFO_FLAGS		"Options    : %s"
#define CS_INFO_END		"*** \2End of Info\2 ***"
#define CS_NEED_EMAIL		"You must have an E-Mail set in %s to use the \2REGISTER\2 command."
#define CS_MLOCK_NEED_PARAM	"Sorry, you must give a %s to ModeLock %s."
#define CS_MLOCK_LIMIT_POSITIVE	"ModeLock Limit must be a positive number."
#define CS_MLOCK_SET		"ModeLock for \2%s\2 changed to \2%s\2."
#define CS_MLOCK_REMOVED	"ModeLock for \2%s\2 removed."
#define CS_AKICK_FULL		"AKick list for \2%s\2 is full. You can only have %d entries."
#define CS_AKICK_ALREADY	"\2%s\2 is already AKicked on \2%s\2."
#define CS_AKICK_ADDED		"\2%s\2 has been AKicked from \2%s\2."
#define CS_AKICK_REMOVED	"\2%s\2 is no longer AKicked from \2%s\2."
#define CS_AKICK_NOT_FOUND	"\2%s\2 is not AKicked on \2%s\2."
#define CS_AKICK_LIST_START	"*** \2AKick list for \2%s\2%s%s%s: \2***"
#define CS_AKICK_LIST_HEADER	"Num Set By                        Mask"
#define CS_AKICK_LIST		"%-3d %-30s%s"
#define CS_AKICK_LIST_REASON	"    Reason: %s"
#define CS_AKICK_LIST_SET	"    Set   : %s ago"
#define CS_AKICK_LIST_END	"*** \2End of list - \2%d\2 match%s shown. \2***"
#define CS_LIST_START		"*** \2%s list for \2%s\2: \2***"
#define CS_LIST_END		"*** \2End of list - \2%d\2 match%s shown. \2***"
#define CS_CHAN_FROZEN		"Channel \2%s\2 is frozen. It cannot be used."
#define CS_ACCESS_DENIED	"Access denied. You must be %s."
#define CS_ACCESS_SELF		"Access denied. You cannot change your own access."
#define CS_ACCESS_DENIED_OTHER	"Access denied. \2%s\2 must be %s."
#define CS_DROPPED		"Channel \2%s\2 has been dropped."
#define CS_ACCESS_ALREADY	"\2%s\2 already has %s access on %s."
#define CS_ACCESS_REGISTERED	"Nickname \2%s\2 is not registered."
#define CS_ACCESS_ADDED		"\2%s\2 has been added to the \2%s\2 %s list."
#define CS_ACCESS_REMOVED	"\2%s\2 has been removed from the \2%s\2 %s list."
#define CS_ACCESS_CHANGED	"Access for \2%s\2 on \2%s\2 has been changed from %s to %s."
#define CS_ACCESS_NOT_FOUND	"No entry matching %s was found on the \2%s\2 %s list."
#define CS_ACCESS_LIST_HEADER	"Num User"
#define CS_ACCESS_LIST		"%-3d %s %s%s%s"
#define CS_REMOVED_SELF		"Your %s access on \2%s\2 has been removed."
#define CS_SUCCESSOR_MEMO	"You are now the owner of \2%s\2, since the previous founder's nickname has expired. The password is \2%s\2."
#define CS_SUCCESSOR_GONE_MEMO	"The nickname you set as successor for \2%s\2, \2%s\2, has expired. Please select another."
#define CS_SUCCESSOR_SELF	"You cannot set the channel successor to the same nick as the channel founder."
#define CS_NO_SUCCESSOR		"Sorry, \2%s\2 doesn't wish to be named channel successor."
#define CS_SUCCESSOR_CHANGE	"\2%s\2 has %s you as the successor of \2%s\2."
#define CS_NO_OP		"Sorry, \2%s\2 doesn't wish to be added to channel access lists."
#define CS_NOT_AUTHED		"Sorry, the channel \2%s\2 is not yet fully registered. It cannot be used."
#define CS_CHAN_LIMIT		"Sorry, you already have %d channels. The most you can own is %d."
#define CS_DROP_SOME		"If you would like to register this channel, please drop one or more other channels you own."
#define CS_LIST_OWNED		"You can see which channels you own by typing \2/%s%s%s%s CHANS\2."
#define CS_CHANS_LIST		"Channels registered to \2%s\2: %s"
#define CS_NO_CHANS		"You do not own any channels."
#define CS_CHAN_LIMIT_OTHER	"\2%s\2 has too many channels. You can not \2SET SUCCESSOR\2 to them."
#define CS_SUCCESSOR_SET	"Successor for \2%s\2 has been set to \2%s\2."
#define CS_GREET		"\2Greet message for %s:\2 %s"
#define CS_VERBOSE_CHANGED	"[VERBOSE] %s changed access for %s from %s to %s."
#define CS_VERBOSE_ADDED	"[VERBOSE] %s added %s to the %s list."
#define CS_VERBOSE_REMOVED	"[VERBOSE] %s removed %s from the %s list."
#define CS_VERBOSE_REMOVED_SELF	"[VERBOSE] %s removed themselves from the %s list."
#define CS_VERBOSE_AKICKED	"[VERBOSE] %s AKicked %s"
#define CS_VERBOSE_UNAKICK	"[VERBOSE] %s removed AKick for %s"
#define CS_VERBOSE_CLEARED	"[VERBOSE] %s cleared %s"
#define CS_FROZEN		"Channel \2%s\2 has been Frozen."
#define CS_UNFROZEN		"Channel \2%s\2 is no longer Frozen."
#define CS_ALREADY_FROZEN	"Channel \2%s\2 is already Frozen."
#define CS_NOT_FROZEN		"Channel \2%s\2 isn't Frozen."
#define CS_RESTRICTED_CHAN	"This channel is restricted"
#define CS_CANT_SENDPASS	"Sorry, the founder for \2%s\2 doesn't have an E-Mail set. Unable to SENDPASS."
#define CS_NOT_ON		"\2%s\2 is not on \2%s\2."
#define CS_IS_ALREADY		"\2%s\2 is already%s on %s."
#define CS_YOURE_ALREADY	"You are already %s on %s."
#define CS_YOURE_NOW		"You are now %s on %s."
#define CS_IS_NOT		"\2%s\2 is not %s on %s."
#define CS_HAS_BEEN		"\2%s\2 has been %s %s%s."
#define CS_YOU_WERE		"You were %s %s \2%s\2 by \2%s\2."
#define CS_IDENTIFY		"You must \2IDENTIFY\2 for \2%s\2 before you can %s."
#define CS_COUNT		"There are %d VOP%s, %s%s%d AOP%s, %d SOP%s, and %d AutoKick%s on \2%s\2."
#define CS_STATUS		"%s%s status on \2%s\2 is \2%s\2."
#define CS_NOT_IN_USE		"Channel \2%s\2 is not in use."
#define CS_NO_BANS		"No matching bans were found on %s."
#define CS_NO_MODES		"No applicable modes are set on %s."
#define CS_BANS_LIST_HEADER	"Num Mask"
#define CS_BANS_LIST		"%-3d %s"
#define CS_ALL_UNBANNED		"All bans were removed on \2%s\2."
#define CS_CHANNEL_MEMO		"[\2%s\2] %s"
#define CS_MEMO_SENT		"Your memo has been sent to \2%d\2 people on \2%s\2."
#define CS_CLEARED		"All %s on \2%s\2 have been cleared."
#define CS_KICK			"%s command from \2%s\2"
#define CS_NOT_FOUNDER		"You are the founder of \2%s\2, you cannot add yourself to the \2%s\2 list."
#define CS_CHAN_MARKED		"Channel \2%s\2 is Marked, unable to %sPASS."
#define CS_MUST_BE_IN		"You must be in \2%s\2 to use \2%s\2."

/* MemoServ Replies */
#define MS_WAIT_SEND		"Please wait %s before sending another memo."
#define MS_FULL_MEMOBOX		"Sorry, \2%s\2 has a full memobox."
#define MS_NOMEMO		"Sorry, \2%s\2 doesn't want to receive memos."
#define MS_SENT			"Your memo has been sent to \2%s\2."
#define MS_NEW_MEMO		"You have a new memo from \2%s\2."
#define MS_TO_LIST		"\2/%s%s%s%s LIST\2 to list your memos."
#define MS_NO_MEMOS		"You have no memos."
#define MS_NO_MEMOS_OTHER	"\2%s\2 has no memos from you."
#define MS_LIST			"Num Status    Sender            Waiting for"
#define MS_LIST_MEMO		"%-3d %-9s %-16s  %s (%s%s)"
#define MS_LIST_OTHER_HEADER	"Listing memos to \2%s\2 from you:"
#define MS_LIST_OTHER		"Num Status    Waiting for"
#define MS_LIST_MEMO_OTHER	"%-3d %-9s %s (%s%s)"
#define MS_MEMO_FROM		"Memo %d from \2%s\2 (sent %s ago):"
#define MS_MEMO			"%s"
#define MS_NO_NEW		"You have no new memos."
#define MS_NO_MEMO_NUM		"You have no memo #%d."
#define MS_NO_MEMO_NUM_OTHER	"\2%s\2 has no memo #%s."
#define MS_NOT_YOURS		"Memo #%s for \2%s\2 was not sent by you."
#define MS_MEMO_RECALLED	"Memo to \2%s\2 has been recalled."
#define MS_ALL_DELETED		"All of your memos have been deleted."
#define MS_READ_DELETED		"\2%d\2 read memos have been deleted."
#define MS_FROM_DELETED		"\2%d\2 memos from \2%s\2 have been deleted."
#define MS_NUM_DELETED		"Memo #%s has been deleted."
#define MS_LIMIT_SIZE		"Your MemoBox limit must be between 1 and %d."
#define MS_ALREADY_READ		"Sorry, \2%s\2 has already read that memo. You can't \2RECALL\2 it."
#define MS_CANT_RECALL_EMAILED	"Sorry, that memo was E-Mailed to \2%s\2. You can't \2RECALL\2 it."
#define MS_TOO_MANY_FROM_YOU	"Sorry, \2%s\2 has too many memos from you."
#define MS_RECEIPT_MEMO		"Memo Receipt: \2%s\2 has received your memo. (%s%s)"
#define MS_NEW_MEMOS		"You have \2%d\2 new memo%s."
#define MS_NEW_NEWS		"There is a new news article available."
#define MS_TO_READ_NEWS		"To read the news, \2/%s%s%s%s NEWS\2"
#define MS_NO_NEWS		"Sorry, there is currently no news."
#define MS_NEWS_START		"*** \2%s News - %s\2 ***"
#define MS_NEWS_END		"*** \2End of News\2 ***"
#define MS_NO_FORWARD		"Sorry, \2%s\2 already has a \2Forward\2 setting. You cannot \2Forward\2 memos to \2%s\2."
#define MS_NEAR_FULL		"Your MemoBox is %sfull. You should delete unneeded memos soon."
#define MS_IF_FULL		"If your MemoBox %sfull, you will not be able to receive new memos."

/* Flag things */
#define NS_OPTION_NOW		"Your \2%s\2 option is now %s."
#define NS_OPTION_ALREADY	"Your \2%s\2 option is already %s."
#define CS_OPTION_NOW		"\2%s\2's \2%s\2 option is now %s."
#define CS_OPTION_ALREADY	"\2%s\2's \2%s\2 option is already %s."
#define FLAG_ENFORCE		"Enforce"
#define FLAG_NEVEROP		"NeverOp"
#define FLAG_NOOP		"NoOp"
#define FLAG_NOSUCCESSOR	"NoSuccessor"
#define FLAG_PRIVATE		"Private"
#define FLAG_SECURE		"Secure"
#define FLAG_RESTRICTED		"Restricted"
#define FLAG_VERBOSE		"Verbose"
#define FLAG_LIMITED		"Limited"
#define FLAG_VOPALL		"VOPAll"
#define FLAG_HELD		"Held"
#define FLAG_MARKED		"Marked"
#define FLAG_MEMOMAIL		"MemoMail"
#define FLAG_RECEIPTS		"Receipts"
#define FLAG_NOMEMO		"NoMemo"
#define FLAG_CSOP		"CSOp"
#define FLAG_SRA		"SRA"
#define FLAG_UNREAD		"Unread"
#define FLAG_EMAILED		"E-Mailed"
#define FLAG_READ		"Read"
